"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _eslintRuleComposer = _interopRequireDefault(require("eslint-rule-composer"));

var _eslint = _interopRequireDefault(require("eslint"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const noInvalidThisRule = new _eslint.default.Linter().getRules().get("no-invalid-this");

var _default = _eslintRuleComposer.default.filterReports(noInvalidThisRule, problem => {
  let inClassMember = false;
  let node = problem.node;

  while (node) {
    if (node.type === "ClassPrivateMethod" || node.type === "ClassPrivateProperty" || node.type === "ClassProperty") {
      inClassMember = true;
      return;
    }

    node = node.parent;
  }

  return !inClassMember;
});

exports.default = _default;